var userid = -1;
var wasOpen = false;

function hidden() {
	CB.Player.stop();
	CB.RealTimeIndex.pause();
}

function shown() {
	CB.RealTimeIndex.resume();
}

function setup() {
	readPrefs();

	new AppleInfoButton($('infoButton'), $('front'), "black", "black", showPrefs);
	new AppleGlassButton($('doneButton'), "Done", hidePrefs);

	CB.Controller.init();
	
	if (window.widget) {
		widget.onhide = hidden;
		widget.onshow = shown;
	}
}

function goBack() {
	if (CB.Transitions.toggle.className == "open") {
		CB.Transitions.foldIn();
		return false;
	}

	return true;
}

function showPrefs() {
	doShowPrefs(false);
}

function doShowPrefs(isOpen) {
	if (!goBack()) {
		setTimeout('doShowPrefs(true);', 600);
		return;
	}

	wasOpen = isOpen;

	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}

	$('front').style.display = "none";
	$('back').style.display = "block";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}

function toFront() {
	widget.performTransition();
	if (wasOpen) {
		setTimeout('CB.Transitions.foldOut();', 800);
	}
}

function hidePrefs() {
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}

	writePrefs();

	CB.User.logOut();
	CB.User.init();

	$('back').style.display = "none";
	$('front').style.display = "block";

	if (window.widget) {
		setTimeout('toFront();', 0);
	}
}

function readPrefs() {
	if (!window.widget) {
		return;
	}

	var username = widget.preferenceForKey("username");
	var password = widget.preferenceForKey("password");
	if (username) {
		$('username').value = username;
	}

	if (password) {
		$('password').value = password;
	}
}

function writePrefs() {
	if (!window.widget) {
		return;
	}

	var user = $('username').value;
	var pass = $('password').value;
	widget.setPreferenceForKey(user, 'username');
	widget.setPreferenceForKey(pass, 'password');
}

window.addEvent('domready', setup);
